<?php

if (!defined('_VALID_MOS') && !defined('_JEXEC'))
    die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

/**
 * @version $Id: paytpv.php,v 2.0
 *
 * @author PayTPV S.L.
 * @package VirtueMart
 * @subpackage payment
 * @copyright Copyright (C) 2012 ZhenIT Sodtware - All rights reserved.
 *
 * http://ZhenIT.com / http://modulosdepago.es
 */
if (!class_exists('vmPSPlugin'))
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');

class plgVmPaymentPaytpv extends vmPSPlugin {

    // instance of class
    public static $_this = false;

    function __construct(& $subject, $config) {

        parent::__construct($subject, $config);

        $this->_loggable = true;
        $this->tableFields = array_keys($this->getTableSQLFields());
        $varsToPush = array('usercode' => array('', 'string'),
            'clientcode' => array('', 'string'),
            'terminal' => array(0, 'int'),
            'password' => array('', 'string'),
            'modo' => array(0, 'int'),
            'countries' => array(0, 'int'),
            'payment_currency' => array(0, 'int'),
            'min_amount' => array(0, 'int'),
            'max_amount' => array(0, 'int'),
            'status_pending' => array('', 'char'),
            'status_success' => array('', 'char'),
            'status_canceled' => array('', 'char'),
            'cost_per_transaction' => array(0, 'int'),
            'cost_percent_total' => array(0, 'int'),
            'tax_id' => array(0, 'int')
        );

        $this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
        // self::$_this = $this;
    }

    /**
     * Create the table for this plugin if it does not yet exist.
     * @author Valérie Isaksen
     */
    protected function getVmPluginCreateTableSQL() {
        return $this->createTableSQL('Payment PayTPV Table');
    }

    /**
     * Fields to create the payment table
     * @return string SQL Fileds
     */
    function getTableSQLFields() {
        $SQLfields = array(
            'id' => 'tinyint(1) unsigned NOT NULL AUTO_INCREMENT',
            'virtuemart_order_id' => 'int(11) UNSIGNED DEFAULT NULL',
            'order_number' => 'char(32) DEFAULT NULL',
            'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED DEFAULT NULL',
            'payment_name' => 'char(255) NOT NULL DEFAULT \'\' ',
            'payment_order_total' => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\' ',
            'payment_currency' => 'char(3) ',
            'cost_per_transaction' => ' decimal(10,2) DEFAULT NULL ',
            'cost_percent_total' => ' decimal(10,2) DEFAULT NULL ',
            'tax_id' => 'smallint(11) DEFAULT NULL',
            'TransactionType' => 'tinyint DEFAULT NULL',
            'TransactionName' => 'char(32) DEFAULT NULL',
            'CardCountry' => 'char(32) DEFAULT NULL',
            'BankDateTime' => 'char(32) DEFAULT NULL',
            'Order' => 'char(255) DEFAULT NULL',
            'ErrorID' => 'int(11) DEFAULT NULL',
            'ErrorDescription' => 'char(255) DEFAULT NULL',
            'AuthCode' => 'char(255) DEFAULT NULL',
            'Currency' => 'char(3) DEFAULT NULL',
            'Amount' => 'int(11) DEFAULT NULL',
            'AmountEur' => 'int(11) DEFAULT NULL',
            'Language' => 'char(32) DEFAULT NULL',
            'AccountCode' => 'char(32) DEFAULT NULL',
            'TpvID' => 'int(11) DEFAULT NULL',            
            'post_raw' => 'text DEFAULT NULL'
        );
        return $SQLfields;
    }

    function plgVmConfirmedOrder($cart, $order) {
        $lang = & JFactory::getLanguage();
        $filename = 'plg_vmpayment_paytpv';
        $lang->load($filename, JPATH_ADMINISTRATOR);

        if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        $session = JFactory::getSession();
        $return_context = $session->getId();
        $this->_debug = $method->debug;
        $this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');

        if (!class_exists('VirtueMartModelOrders'))
            require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
        if (!class_exists('VirtueMartModelCurrency'))
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');

        //$usr = & JFactory::getUser();
        $new_status = '';

        $address = ((isset($order['details']['ST'])) ? $order['details']['ST'] : $order['details']['BT']);

        $vendorModel = new VirtueMartModelVendor();
        $vendorModel->setId(1);
        $vendor = $vendorModel->getVendor();
        $this->getPaymentCurrency($method);
        $q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
        $db = &JFactory::getDBO();
        $db->setQuery($q);
        $currency_code_3 = $db->loadResult();

        $paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
        $totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false) * 100);
        $cd = CurrencyDisplay::getInstance($cart->pricesCurrency);

//         $urlok = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id);
//         $urlko = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id);
        $urlok = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id);
        $urlko = $urlok;
        
        $message = $totalInPaymentCurrency . $ds_merchant_order . $method->merchantcode . $currency_code_3 . $ds_merchant_transactiontype . $ds_merchant_merchanturl . $clave;
        $firma = md5($method->clientcode.$method->usercode.$method->terminal."1".$order['details']['BT']->order_number.$totalInPaymentCurrency.$currency_code_3.md5($method->password));
//EOF Signature cal);

        $consumerlanguage = JText::_('VMPAYMENT_PAYTPV_IDIOMA') == 'VMPAYMENT_PAYTPV_IDIOMA' ? '1' : JText::_('VMPAYMENT_PAYTPV_IDIOMA');

        $post_variables = Array(
            'ACCOUNT' => $method->clientcode,
            'TERMINAL' => $method->terminal,
            'USERCODE' => $method->usercode,
            "OPERATION" => '1',
            "REFERENCE" => $order['details']['BT']->order_number,
            "AMOUNT" => $totalInPaymentCurrency,
            "CURRENCY" => $currency_code_3,
            "SIGNATURE" => $firma,
            "URLOK" => $urlok,
            "URLKO" => $urlko
        );
        // Prepare data that should be stored in the database
        $dbValues = array();
        $dbValues['virtuemart_order_id'] = $order['details']['BT']->virtuemart_order_id;
        $dbValues['order_number'] = $order['details']['BT']->order_number;
        $dbValues['payment_name'] = $this->renderPluginName($method, $order);
        $dbValues['virtuemart_paymentmethod_id'] = $cart->virtuemart_paymentmethod_id;
        $dbValues['return_context'] = $return_context;
        $dbValues['cost_per_transaction'] = $method->cost_per_transaction;
        $dbValues['cost_percent_total'] = $method->cost_percent_total;
        $dbValues['payment_currency'] = $method->payment_currency;
        $dbValues['payment_order_total'] = $totalInPaymentCurrency / 100;
        $dbValues['tax_id'] = $method->tax_id;
        $this->storePSPluginInternalData($dbValues);

        if($method->modo==1){
            $url = 'https://www.paytpv.com/gateway/ifgateway.php?';
            foreach ($post_variables as $name => $value) {
                $url.= $name . '=' . htmlspecialchars($value) . '&';
            }
            $html = '<iframe src="'.$url.'"name="paytpv" style="width: 670px; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-style: initial; border-color: initial; border-image: initial; height: 322px; " marginheight="0" marginwidth="0" scrolling="no"></iframe>';
        }else{
        // add spin image
            $url = 'https://www.paytpv.com/gateway/fsgateway.php';
        
            $html = '<form action="' . $url . '" method="post" name="vm_paytpv_form" id="vm_paytpv_form">';
        //$html.= JText::_('VMPAYMENT_PAYTPV_CONNECTING');
        //$html.= '<input type="submit" name="submit" value="Pago seguro" />';
            foreach ($post_variables as $name => $value) {
                $html.= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
            }
            $html.= '</form>';

            $html.= ' <script type="text/javascript">';
            $html.= '    document.getElementById("vm_paytpv_form").submit();';
            $html.= ' </script>';
        }
        //  2 = don't delete the cart, don't send email and don't redirect
        return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $new_status);
    }

    /**
     * Display stored payment data for an order
     *
     */
    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id) {
        $lang = & JFactory::getLanguage();
        $filename = 'plg_vmpayment_paytpv';
        $lang->load($filename, JPATH_ADMINISTRATOR);

        if (!$this->selectedThisByMethodId($virtuemart_payment_id)) {
            return null; // Another method was selected, do nothing
        }

        $db = JFactory::getDBO();
        $q = 'SELECT * FROM `' . $this->_tablename . '` '
                . 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
        $db->setQuery($q);
        if (!($paymentTable = $db->loadObject())) {
            vmWarn(500, $q . " " . $db->getErrorMsg());
            return '';
        }
        $this->getPaymentCurrency($paymentTable);

        $html = '<table class="adminlist">' . "\n";
        $html .=$this->getHtmlHeaderBE();
        $html .= $this->getHtmlRowBE('STANDARD_PAYMENT_NAME', $paymentTable->payment_name);
        $html .= $this->getHtmlRowBE('STANDARD_PAYMENT_TOTAL_CURRENCY', $paymentTable->payment_order_total . ' ' . $paymentTable->payment_currency);
        $html .= '</table>' . "\n";
        return $html;
    }

    function _getPaymentResponseHtml($payment_data, $payment_name) {
        $lang = & JFactory::getLanguage();
        $filename = 'plg_vmpayment_paytpv';
        $lang->load($filename, JPATH_ADMINISTRATOR);
        if (!class_exists('CurrencyDisplay'))
            require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'currencydisplay.php');
        $currency = CurrencyDisplay::getInstance();
        vmdebug('paytpv response', $payment_data);

        $html = '<table>' . "\n";
        $html .= $this->getHtmlRow('PAYTPV_ORDER_NUMBER', $payment_data->order_number);
        $html .= $this->getHtmlRow('PAYTPV_AMOUNT', $currency->priceDisplay($payment_data->payment_order_total));

        $html .= '</table>' . "\n";

        return $html;
    }

    function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
        if (preg_match('/%$/', $method->cost_percent_total)) {
            $cost_percent_total = substr($method->cost_percent_total, 0, -1);
        } else {
            $cost_percent_total = $method->cost_percent_total;
        }
        return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
    }

    /**
     * Check if the payment conditions are fulfilled for this payment method
     *
     * @param $cart_prices: cart prices
     * @param $payment
     * @return true: if the conditions are fulfilled, false otherwise
     *
     */
    protected function checkConditions($cart, $method, $cart_prices) {

        $address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

        $amount = $cart_prices['salesPrice'];
        $amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
                OR
                ($method->min_amount <= $amount AND ($method->max_amount == 0) ));
        if (!$amount_cond) {
            return false;
        }
        $countries = array();
        if (!empty($method->countries)) {
            if (!is_array($method->countries)) {
                $countries[0] = $method->countries;
            } else {
                $countries = $method->countries;
            }
        }

        // probably did not gave his BT:ST address
        if (!is_array($address)) {
            $address = array();
            $address['virtuemart_country_id'] = 0;
        }

        if (!isset($address['virtuemart_country_id']))
            $address['virtuemart_country_id'] = 0;
        if (count($countries) == 0 || in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
            return true;
        }

        return false;
    }

    /*
     * We must reimplement this triggers for joomla 1.7
     */

    /**
     * Create the table for this plugin if it does not yet exist.
     * This functions checks if the called plugin is active one.
     * When yes it is calling the standard method to create the tables
     *
     *
     */
    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {
        return $this->onStoreInstallPluginTable($jplugin_id);
    }

    /**
     * This event is fired after the payment method has been selected. It can be used to store
     * additional payment info in the cart.
     *
     *
     * @param VirtueMartCart $cart: the actual cart
     * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
     *
     */
    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
        return $this->OnSelectCheck($cart);
    }

    /**
     * plgVmDisplayListFEPayment
     * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
     *
     * @param object $cart Cart object
     * @param integer $selected ID of the method selected
     * @return boolean True on succes, false on failures, null when this plugin was not selected.
     * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
     *
     *
     */
    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
        return $this->displayListFE($cart, $selected, $htmlIn);
    }

    /*
     * plgVmonSelectedCalculatePricePayment
     * Calculate the price (value, tax_id) of the selected method
     * It is called by the calculator
     * This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
     *
     * @cart: VirtueMartCart the current cart
     * @cart_prices: array the new cart prices
     * @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
     *
     *
     */

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
        return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {

        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        $this->getPaymentCurrency($method);

        $paymentCurrencyId = $method->payment_currency;
    }

    function plgVmOnPaymentResponseReceived(&$html) {
        $lang = & JFactory::getLanguage();
        $filename = 'plg_vmpayment_paytpv';
        $lang->load($filename, JPATH_ADMINISTRATOR);
        
// the payment itself should send the parameter needed.
        $virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);

        $vendorId = 0;
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }

        vmdebug('plgVmOnPaymentResponseReceived', $payment_data);
        $order_number = JRequest::getVar('on');
        if (!class_exists('VirtueMartModelOrders'))
            require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );

        $virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
        $payment_name = $this->renderPluginName($method);
        $payment_data = $this->getDataByOrderId($virtuemart_order_id);
        $html = $this->_getPaymentResponseHtml($payment_data, $payment_name);

        if ($virtuemart_order_id) {
            if (!class_exists('VirtueMartCart'))
                require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
            // get the correct cart / session
            $cart = VirtueMartCart::getCart();
            $cart->emptyCart();
        }

        return true;
    }

    function plgVmOnUserPaymentCancel() {
        $lang = & JFactory::getLanguage();
        $filename = 'plg_vmpayment_paytpv';
        $lang->load($filename, JPATH_ADMINISTRATOR);

        if (!class_exists('VirtueMartModelOrders'))
            require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );

        $order_number = JRequest::getVar('on');
        if (!$order_number)
            return false;
        $db = JFactory::getDBO();
        $query = 'SELECT ' . $this->_tablename . '.`virtuemart_order_id` FROM ' . $this->_tablename . " WHERE  `order_number`= '" . $order_number . "'";

        $db->setQuery($query);
        $virtuemart_order_id = $db->loadResult();

        if (!$virtuemart_order_id) {
            return null;
        }
        $this->handlePaymentUserCancel($virtuemart_order_id);

        //JRequest::setVar('paymentResponse', $returnValue);
        return true;
    }

    /*
     *   plgVmOnPaymentNotification() - This event is fired by Offline Payment. It can be used to validate the payment data as entered by the user.
     * Return:
     * Parameters:
     *  None
     *
     */

    function plgVmOnPaymentNotification() {
        $lang = & JFactory::getLanguage();
        $filename = 'plg_vmpayment_paytpv';
        $lang->load($filename, JPATH_ADMINISTRATOR);

        $paytpv_data = JRequest::get();
        if (!class_exists('VirtueMartModelOrders'))
            require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );

        $order_number = $paytpv_data['on'];
        $virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
        $payment_data = $this->getDataByOrderId($virtuemart_order_id);
        $this->logInfo('plgVmOnPaymentNotification: virtuemart_order_id  found ' . $virtuemart_order_id, 'message');

        $urlok = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&on=' . $order_number . '&pm=' .$paytpv_data['pm']);

        $urlko = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . $order_number . '&pm=' . $paytpv_data['pm']);
        if (!$virtuemart_order_id) {
            $this->_debug = true; // force debug here
            $this->logInfo('plgVmOnPaymentNotification: virtuemart_order_id not found ', 'ERROR');
            // send an email to admin, and ofc not update the order status: exit  is fine
            $this->sendEmailToVendorAndAdmins(JText::_('VMPAYMENT_PAYTPV_ERROR_EMAIL_SUBJECT'), JText::_('VMPAYMENT_PAYTPV_UNKNOW_ORDER_ID'));
            exit;
        }
        $vendorId = 0;
        $payment = $this->getDataByOrderId($virtuemart_order_id);

        $method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }

        $this->_debug = $method->debug;
        if (!$payment) {
            $this->logInfo('getDataByOrderId payment not found: exit ', 'ERROR');
            return null;
        }
        $this->logInfo('paytpv_data ' . serialize($paytpv_data), 'message');

        $_firma = md5($method->usercode.$paytpv_data["r"].$method->password.$paytpv_data["ret"]);

        if ($paytpv_data['h'] != $_firma) {
            $this->_debug = true; // force debug here
            $this->logInfo('plgVmOnPaymentNotification: virtuemart_order_id not found ', 'ERROR');
            // send an email to admin, and ofc not update the order status: exit  is fine
            $this->sendEmailToVendorAndAdmins(JText::_('VMPAYMENT_PAYTPV_ERROR_EMAIL_SUBJECT'), sprintf(JText::_('VMPAYMENT_PAYTPV_ILEGAL_ACCESS'), JRequest::getVar('REMOTE_ADDR', null, 'server')));
            echo "<script type='text/javascript'>window.top.location.href='".$urlko."'</script>";
            exit;
        }
        $url = '';
        $new_status = $method->status_pending;
        $comments = '';
        if ((int) $paytpv_data['ret']!=0) {
            //Transacci&oacute;n denegada
            $new_status = $method->status_canceled;
            $comments = JText::sprintf('VMPAYMENT_PAYTPV_PAYMENT_CANCELLED', $order_number);
            $url = $urlko;
            //$this->sendEmailToVendorAndAdmins(JText::_('VMPAYMENT_PAYTPV_ERROR_EMAIL_SUBJECT'), sprintf(JText::_('VMPAYMENT_PAYTPV_FAILED_PAYMENT_ATTEMPT'),$this->_getErrorMsg($paytpv_data['Ds_Response'])));
        } else {
            $new_status = $method->status_success;
            $url = $urlok;
            $comments = JText::sprintf('VMPAYMENT_PAYTPV_PAYMENT_CONFIRMED', $order_number);
        }
        $response_fields = array();
        $response_fields['payment_name'] = $this->renderPluginName($method);
        $response_fields['virtuemart_paymentmethod_id'] = $payment_data->virtuemart_paymentmethod_id;
        $response_fields['order_number'] = $payment_data->order_number;
        $response_fields['return_context'] = $payment_data->return_context;
        $response_fields['cost_per_transaction'] = $payment_data->cost_per_transaction;
        $response_fields['cost_percent_total'] = $payment_data->cost_percent_total;
        $response_fields['payment_currency'] = $payment_data->payment_currency;
        $response_fields['payment_order_total'] = $payment_data->payment_order_total;
        $response_fields['tax_id'] = $payment_data->tax_id;
        $response_fields['virtuemart_order_id'] = $virtuemart_order_id;
        $response_fields['post_raw'] = serialize($paytpv_data);

        $response_fields['TransactionType'] = $paytpv_data['TransactionType'];
        $response_fields['TransactionName'] = $paytpv_data['TransactionName'];
        $response_fields['CardCountry'] = $paytpv_data['CardCountry'];
        $response_fields['BankDateTime'] = $paytpv_data['BankDateTime'];
        $response_fields['Order'] = $paytpv_data['Order'];
        $response_fields['ErrorID'] = $paytpv_data['ErrorID'];
        $response_fields['ErrorDescription'] = $paytpv_data['ErrorDescription'];
        $response_fields['AuthCode'] = $paytpv_data['AuthCode'];        $response_fields['Currency'] = $paytpv_data['Currency'];        $response_fields['Amount'] = $paytpv_data['Amount'];        $response_fields['AmountEur'] = $paytpv_data['AmountEur'];        $response_fields['Language'] = $paytpv_data['Language'];        $response_fields['AccountCode'] = $paytpv_data['AccountCode'];$response_fields['TpvID'] = $paytpv_data['TpvID'];        
        $this->storePSPluginInternalData($response_fields, 'virtuemart_order_id', true);
        $this->logInfo('process PayTPV notificación OK, status', 'message');

        if ($virtuemart_order_id) {
            // send the email only if payment has been accepted
            if (!class_exists('VirtueMartModelOrders'))
                require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
            $modelOrder = new VirtueMartModelOrders();
            $order = array();
            $order['order_status'] = $new_status;
            $order['virtuemart_order_id'] = $virtuemart_order_id;
            $order['customer_notified'] = 1;
            $order['comments'] = $comments;
            $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
            // remove vmcart
        }
        echo "<script type='text/javascript'>window.top.location.href='" . $url . "'</script>";
        exit;
    }

    /**
     * plgVmOnCheckAutomaticSelectedPayment
     * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
     * The plugin must check first if it is the correct type
     *
     * @param VirtueMartCart cart: the cart object
     * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
     *
     */
    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
        return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }

    /**
     * This method is fired when showing the order details in the frontend.
     * It displays the method-specific data.
     *
     * @param integer $order_id The order ID
     * @return mixed Null for methods that aren't active, text (HTML) otherwise
     *
     *
     */
    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
        $this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    /**
     * This event is fired during the checkout process. It can be used to validate the
     * method data as entered by the user.
     *
     * @return boolean True when the data was valid, false otherwise. If the plugin is not activated, it should return null.
     *

      public function plgVmOnCheckoutCheckDataPayment(  VirtueMartCart $cart) {
      return null;
      }
     */

    /**
     * This method is fired when showing when priting an Order
     * It displays the the payment method-specific data.
     *
     * @param integer $_virtuemart_order_id The order ID
     * @param integer $method_id  method used for this order
     * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
     *
     */
    function plgVmonShowOrderPrintPayment($order_number, $method_id) {
        return $this->onShowOrderPrint($order_number, $method_id);
    }

    function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
        return $this->declarePluginParams('payment', $name, $id, $data);
    }

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
        return $this->setOnTablePluginParams($name, $id, $table);
    }

}

// No closing tag